local rt = RoosterTools
local db = {}

local defaultDb = {
    partyGuid = nil,
    config = {
        raid = {
            minGuildMembers = 10
        },
        party = {
            minGuildMembers = 4
        },
        sync = {
            refuseRankBelow = 5 -- Below actually indicates greater given 0 is the highest guild rank. 
        }
    },
    characters = {},
    groups = {},
    mains = {},
    sync = {},
    aliases = {},
    debug = false,
}

RoosterToolsDBConn = {}

function RoosterToolsDBConn:SelectCharacterByName(name) 
    for k, v in pairs(db.characters) do
        if (string.lower(v.unitName) == string.lower(name)) then
            return k, v
        end
    end

    return nil
end

function RoosterToolsDBConn:SelectGuildRaidGroups() 
    local t = {}
    
    for k, v in pairs(db.groups) do
        if (v.guildGroupTime and v.type == "raid") then
            for k, v in pairs(v.instances) do
                -- dump some of the weird raid events that have 'pvp' as the instance type. 
                if (v.type == "raid") then
                    t[k] = v
                end
            end
        end
    end

    return t
end

function RoosterToolsDBConn:SelectGuildGroups() 
    local t = {}
    
    for k, v in pairs(db.groups) do
        if (v.guildGroupTime) then
            t[k] = v
        end
    end

    return t
end

function RoosterToolsDBConn:OnInitialize() 
    db = RoosterToolsDB

     -- Init the db if it hasn't been used.
     if (not db) then
        RoosterToolsDB = defaultDb
        db = RoosterToolsDB
    end

    if (not db.aliases) then
        -- DB Upgrade
        db.aliases = {}
    end

    if (not db.debug) then
        db.debug = false
    end

    if (not db.config.sync or not db.config.sync.refuseRankBelow) then
        db.config.sync = defaultDb.config.sync
    end
end
